<?php
/**
 * $Id: cgp.php 30 2011-12-23 17:35:13Z h0ax $
 *
 * osCommerce, Open Source E-Commerce Solutions
 * http://www.oscommerce.com
 *
 * Copyright (c) 2007 osCommerce
 *
 * Released under the GNU General Public License
 *
 * Modified by Ramon de la Fuente (ramon@future500.nl) for new osCommerce checkout (>Nov 2002) procedure.
 * Tested with CGP eCommerce version Jan 2003 and later. For more
 * infomation about Card Gate Plus: http://www.cardgateplus.com
 *
 * Modified by BZ (support@cardgate.com):
 * - Removed IP check and build in HASH check
 *  version 2.10 2010-06-21
 * 
 * Modified by Paul Saparov (support@cardgate.com)
 * version 2.31 2011-11-02
 * 
 * Modified by Paul Saparov (support@cardgate.com)
 * version 2.32 2011-11-11
 * 
 * Modified by Paul Saparov (support@cardgate.com)
 * version 2.33 2011-12-21
 */
chdir('../../../../');
require('includes/application_top.php');

// format prices without currency formatting
function format_raw($number, $currency_code = '', $currency_value = '')
{
    global $currencies, $currency;
    
    $number = preg_replace("/^[^0-9\.]/", "", $number);

    if (empty($currency_code) || !$currencies->is_set($currency_code)) {
        $currency_code = $currency;
    }

    if (empty($currency_value) || !is_numeric($currency_value)) {
        $currency_value = $currencies->currencies[$currency_code]['value'];
    }

    return number_format(tep_round($number * $currency_value, $currencies->currencies[$currency_code]['decimal_places']), $currencies->currencies[$currency_code]['decimal_places'], '.', '');
}

$ok              = true;
$send_warning    = false;

reset($HTTP_POST_VARS);

$ref             = $HTTP_POST_VARS['ref'];
$ar              = explode('|', $ref);
$order_id        = $ar[0];
$cgp_id          = $ar[1];
$transaction_id  = $HTTP_POST_VARS['transactionid'];
$is_test         = $HTTP_POST_VARS['is_test'];
$status          = $HTTP_POST_VARS['status'];
$currency        = $HTTP_POST_VARS['currency'];
$amount          = $HTTP_POST_VARS['amount'];

if ($HTTP_POST_VARS['billing_option'] != 'creditcard') {
    $module_cgp_text = strtoupper($HTTP_POST_VARS['billing_option']);
} else {
    $cgp_module = tep_db_fetch_array(tep_db_query("SELECT module FROM  CGP_orders_table WHERE ref_id=$cgp_id"));
    $module_cgp_text = strtoupper(str_replace("cgp_", "", $cgp_module['module']));
}
$hashKey = @constant("MODULE_PAYMENT_CGP_" . $module_cgp_text . "_KEYCODE");

if ($ok) {
    if (count($HTTP_POST_VARS) == 0) {
        $ok = false; $send_warning = false;
    }
}

if ($ok) {
    $my_order_query = tep_db_query("select orders_status, currency, currency_value from ".TABLE_ORDERS." where orders_id = '$order_id'");
    if (tep_db_num_rows($my_order_query) <= 0) {
        $ok = false; $send_warning = true;
        $email_subject = "Missing order in database";
        $email_text    = "Order with assigned ID ($order_id) not found in database.";
    }
}

$hash_uncoded = ($is_test == 1 ? "TEST" : "") . 
                $transaction_id .
                $currency .
                $amount .
                $ref .
                $status .
                $hashKey;


if ($ok) {
    if (md5($hash_uncoded) != $HTTP_POST_VARS["hash"]) {
        $ok = false; $send_warning = true;
        $email_subject = 'Security warning: Wrong HASH received in CGP callback';
        $email_text = "Received wrong parameters in a callback request:\n\n";

        ob_start();
        echo "REMOTE HOST:\n" . $_SERVER['REMOTE_ADDR'] . "\n";
        echo "\nGET:\n";
        print_r($HTTP_GET_VARS);
        echo "\nPOST:\n";
        print_r($HTTP_POST_VARS);
        $email_text .= ob_get_clean();
    }
}

if ($ok) {
    require (DIR_WS_CLASSES.'order.php');
    $order = new order($order_id);
    $order_amount = round($order->info['total_value'],2)*100; //format_raw($order->info['total'], $order->info['currency']) * 100;
    
    $order_status = constant("MODULE_PAYMENT_CGP_" . $module_cgp_text . "_ORDER_INITIAL_STATUS_ID");
    $sql_data_array = array(
        'orders_status' => $order_status,
        'last_modified' => 'now()'
    );
    tep_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = ' . $order_id);
    
    $sql_data_array = array(
        'orders_id' => $order_id,
        'orders_status_id' => $order_status,
        'date_added' => 'now()',
        'customer_notified' => (SEND_EMAILS == 'true') ? '1' : '0',
        'comments' => $order->info['comments']);
    tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
    
    if (($order_amount != $amount) && 
        (round($order_amount) != $amount) && 
        (abs($amount - $order_amount) > 1)) {
        $ok = false; $send_warning = false;
        $email_subject = "Hacker attempt";
        $email_text    = "Order total amount in cents ($order_amount) does not match CardGatePlus's gross total amount in cents ($amount)!";
        
        $comment_status = "Hacker attempt: Order total amount does not match CardGatePlus's gross total amount!";
        $order_status = constant("MODULE_PAYMENT_CGP_" . $module_cgp_text . "_ORDER_FAILED_STATUS_ID");
        
        // Add status history
        $sql_data_array = array(
            'orders_id'         => $order_id,
            'orders_status_id'  => $order_status,
            'date_added'        =>'now()',
            'customer_notified' => '0',
            'comments'          => $comment_status
        );
        tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

        $sql_data_array = array(
            'orders_status' => $order_status,
            'last_modified' => 'now()'
        );
        tep_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = ' . $order_id);
    }
}

if ($ok) {
    $sql_data_array = array(
        'transaction_id' => $transaction_id,
        'status' => $status,
        'order_id' => $order_id
    );
    tep_db_perform('CGP_orders_table', $sql_data_array, 'update', 'ref_id =' . $cgp_id);

    // Update order status
    switch ($status) {
        case "200":
            $comment_status = "Payment complete.";
            $order_status = constant("MODULE_PAYMENT_CGP_" . $module_cgp_text . "_ORDER_PAID_STATUS_ID");
            break;
        case "300":
        case "301":
            $comment_status = "Payment failed or canceled by user.";
            $order_status = constant("MODULE_PAYMENT_CGP_" . $module_cgp_text . "_ORDER_FAILED_STATUS_ID");
            break;
        default:
            $comment_status = "";
            $order_status = constant("MODULE_PAYMENT_CGP_" . $module_cgp_text . "_ORDER_INITIAL_STATUS_ID");
            break;
    }

    // Add status history
    $sql_data_array = array(
        'orders_id'         => $order_id,
        'orders_status_id'  => $order_status,
        'date_added'        =>'now()',
        'customer_notified' => '0',
        'comments'          => $comment_status
    );
    tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

    $sql_data_array = array(
        'orders_status' => $order_status,
        'last_modified' => 'now()'
    );
    tep_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = ' . $order_id);    
}

if ($send_warning) {
    tep_mail(STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS, $email_subject, $email_text, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
}

echo $transaction_id . "." . $status;

require('includes/application_bottom.php');
?>