<?php
/**
 * $Id: cgp_generic.php 30 2011-12-23 17:35:13Z h0ax $
 * 
 * osCommerce, Open Source E-Commerce Solutions
 * http://www.oscommerce.com
 * 
 * Copyright (c) 2002 osCommerce
 * 
 * Released under the GNU General Public License
 * 
 * Created by BZ (support@cardgate.com)
 * version 2.10 2010-06-21
 * 
 * Modified by Paul Saparov (support@cardgate.com)
 * version 2.31 2011-11-02
 * 
 * Modified by Paul Saparov (support@cardgate.com)
 * version 2.32 2011-11-11
 * 
 * Modified by Paul Saparov (support@cardgate.com)
 * version 2.33 2011-12-21
 * 
 * Modified by Richard Schoots (support@cardgate.com)
 * version 2.34 2014-01-28
 */
class cgp_generic
{
    var $code;
    var $module_cgp_text;
    
    var $title;
    var $sort_order;
    var $description;
    var $enabled;
    
    var $form_action_url = "https://gateway.cardgateplus.com/";
    
    // Cardgate TEST
    //var $form_action_url = "http://gateway.cardgate.dev/";
    
    /**
     * Constructor
     */
	function cgp_generic()
	{
        global $order;
        
        $this->title       = @constant("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_TEXT_TITLE");
        $this->description = @constant("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_TEXT_DESCRIPTION");
        $this->signature   = "cardgateplus|cardgateplus|2.38|2.2";
        
        $this->sort_order  = defined("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_SORT_ORDER") ? 
                constant("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_SORT_ORDER") : 0;
        
        $this->enabled     = (defined("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_STATUS") && 
                (constant("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_STATUS") == 'True') ? true : false);
        
        if (is_object($order)) {
            $this->update_status();
        }
	}
    
    /**
     * Check whether this payment module is available
     * 
     * @return void
     */
	function update_status()
	{
		if ($this->enabled && ((int)constant("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_KEYCODE") > 0)) {
			$check_flag  = false;
			$check_query = tep_db_query("SELECT zone_id FROM " . TABLE_ZONES_TO_GEO_ZONES . " WHERE geo_zone_id = '" . constant("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_ZONE") . "' AND zone_country_id = '" . $GLOBALS['order']->billing['country']['id'] . "' ORDER BY zone_id");

			while ($check = tep_db_fetch_array($check_query)) {
				if ($check['zone_id'] < 1) {
					$check_flag = true;
					break;
				} else if ($check['zone_id'] == $GLOBALS['order']->billing['zone_id']) {
					$check_flag = true;
					break;
				}
			}

			if (!$check_flag) {
				$this->enabled = false;
			}
		}
	}
    
    /**
	 * Client side javascript that will verify any input 
     * fields you use in the payment method selection page
     *
     * @return boolean False 
     */
    function javascript_validation()
    {
        return false;
    }

    /**
     * Outputs the payment method title/text and if required, 
     * the input fields
     * 
     * @global type $cart_cgp_ID
     * @return array
     */
    function selection()
    {
        global $cart_cgp_ID;

        if (tep_session_is_registered('cart_cgp_ID')) {
            $order_id = substr($cart_cgp_ID, strpos($cart_cgp_ID, '-')+1);

            $check_query = tep_db_query('select orders_id from '.TABLE_ORDERS_STATUS_HISTORY.' where orders_id = "'.(int)$order_id.'" limit 1');
            
            if (tep_db_num_rows($check_query) < 1)
            {
                tep_session_unregister('cart_cgp_ID');
            }
        }
        
        return array(
            'id' => $this->code,
            'module' => $this->title
        );
    }
    
    /**
     * Any checks of any conditions after payment method has been selected
     * 
     * @global type $cartID
     * @global type $cart 
     */
    function pre_confirmation_check()
    {
        global $cartID;
        global $cart;

        if ( empty($cart->cartID)) {
            $cartID = $cart->cartID = $cart->generate_cart_id();
        }

        if (!tep_session_is_registered('cartID')) {
            tep_session_register('cartID');
        }
    }
    
    /**
	 * Any checks or processing on the order information before 
     * proceeding to payment confirmation
     * 
     * @global type $cartID
     * @global type $cart_cgp_ID
     * @global type $customer_id
     * @global type $languages_id
     * @global type $order
     * @global type $order_total_modules
     * @return array 
     */
    function confirmation()
    {
        global $cartID;
        global $cart_cgp_ID;
        global $customer_id;
        global $languages_id;
        global $order;
        global $order_total_modules;
        
        if (tep_session_is_registered('cartID'))
        {
            $insert_order = false;
            
            if (tep_session_is_registered('cart_cgp_ID'))
            {
                $order_id = substr($cart_cgp_ID, strpos($cart_cgp_ID, '-')+1);

                $curr_check = tep_db_query("select currency from ".TABLE_ORDERS." where orders_id = '".(int)$order_id."'");
                $curr = tep_db_fetch_array($curr_check);

                if (($curr['currency'] != $order->info['currency']) || ($cartID != substr($cart_cgp_ID, 0, strlen($cartID))))
                {
                    $check_query = tep_db_query('select orders_id from '.TABLE_ORDERS_STATUS_HISTORY.' where orders_id = "'.(int)$order_id.'" limit 1');

                    if (tep_db_num_rows($check_query) < 1)
                    {
                        tep_db_query('delete from '.TABLE_ORDERS.' where orders_id = "'.(int)$order_id.'"');
                        tep_db_query('delete from '.TABLE_ORDERS_TOTAL.' where orders_id = "'.(int)$order_id.'"');
                        tep_db_query('delete from '.TABLE_ORDERS_STATUS_HISTORY.' where orders_id = "'.(int)$order_id.'"');
                        tep_db_query('delete from '.TABLE_ORDERS_PRODUCTS.' where orders_id = "'.(int)$order_id.'"');
                        tep_db_query('delete from '.TABLE_ORDERS_PRODUCTS_ATTRIBUTES.' where orders_id = "'.(int)$order_id.'"');
                        tep_db_query('delete from '.TABLE_ORDERS_PRODUCTS_DOWNLOAD.' where orders_id = "'.(int)$order_id.'"');
                    }

                    $insert_order = true;
                }
            } else {
                $insert_order = true;
            }
            

            if ($insert_order == true)
            {
                $order_totals = array ();
                if (is_array($order_total_modules->modules))
                {
                    reset($order_total_modules->modules);
                    while ( list (, $value) = each($order_total_modules->modules))
                    {
                        $class = substr($value, 0, strrpos($value, '.'));
                        if ($GLOBALS[$class]->enabled)
                        {
                            for ($i = 0, $n = sizeof($GLOBALS[$class]->output); $i < $n; $i++)
                            {
                                if (tep_not_null($GLOBALS[$class]->output[$i]['title']) && tep_not_null($GLOBALS[$class]->output[$i]['text']))
                                {
                                    $order_totals[] = array ('code'=>$GLOBALS[$class]->code,
                                    'title'=>$GLOBALS[$class]->output[$i]['title'],
                                    'text'=>$GLOBALS[$class]->output[$i]['text'],
                                    'value'=>$GLOBALS[$class]->output[$i]['value'],
                                    'sort_order'=>$GLOBALS[$class]->sort_order);
                                }
                            }
                        }
                    }
                }

                $sql_data_array = array ('customers_id'=>$customer_id,
                'customers_name'=>$order->customer['firstname'].' '.$order->customer['lastname'],
                'customers_company'=>$order->customer['company'],
                'customers_street_address'=>$order->customer['street_address'],
                'customers_suburb'=>$order->customer['suburb'],
                'customers_city'=>$order->customer['city'],
                'customers_postcode'=>$order->customer['postcode'],
                'customers_state'=>$order->customer['state'],
                'customers_country'=>$order->customer['country']['title'],
                'customers_telephone'=>$order->customer['telephone'],
                'customers_email_address'=>$order->customer['email_address'],
                'customers_address_format_id'=>$order->customer['format_id'],
                'delivery_name'=>$order->delivery['firstname'].' '.$order->delivery['lastname'],
                'delivery_company'=>$order->delivery['company'],
                'delivery_street_address'=>$order->delivery['street_address'],
                'delivery_suburb'=>$order->delivery['suburb'],
                'delivery_city'=>$order->delivery['city'],
                'delivery_postcode'=>$order->delivery['postcode'],
                'delivery_state'=>$order->delivery['state'],
                'delivery_country'=>$order->delivery['country']['title'],
                'delivery_address_format_id'=>$order->delivery['format_id'],
                'billing_name'=>$order->billing['firstname'].' '.$order->billing['lastname'],
                'billing_company'=>$order->billing['company'],
                'billing_street_address'=>$order->billing['street_address'],
                'billing_suburb'=>$order->billing['suburb'],
                'billing_city'=>$order->billing['city'],
                'billing_postcode'=>$order->billing['postcode'],
                'billing_state'=>$order->billing['state'],
                'billing_country'=>$order->billing['country']['title'],
                'billing_address_format_id'=>$order->billing['format_id'],
                'payment_method'=>$order->info['payment_method'],
                'cc_type'=>$order->info['cc_type'],
                'cc_owner'=>$order->info['cc_owner'],
                'cc_number'=>$order->info['cc_number'],
                'cc_expires'=>$order->info['cc_expires'],
                'date_purchased'=>'now()',
                'orders_status'=>constant('MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_ORDER_INITIAL_STATUS_ID'),
                'currency'=>$order->info['currency'],
                'currency_value'=>$order->info['currency_value']);

                tep_db_perform(TABLE_ORDERS, $sql_data_array);

                $insert_id = tep_db_insert_id();

                for ($i = 0, $n = sizeof($order_totals); $i < $n; $i++)
                {
                    $sql_data_array = array ('orders_id'=>$insert_id,
                    'title'=>$order_totals[$i]['title'],
                    'text'=>$order_totals[$i]['text'],
                    'value'=>$order_totals[$i]['value'],
                    'class'=>$order_totals[$i]['code'],
                    'sort_order'=>$order_totals[$i]['sort_order']);

                    tep_db_perform(TABLE_ORDERS_TOTAL, $sql_data_array);
                }

                for ($i = 0, $n = sizeof($order->products); $i < $n; $i++)
                {
                    $sql_data_array = array ('orders_id'=>$insert_id,
                    'products_id'=>tep_get_prid($order->products[$i]['id']),
                    'products_model'=>$order->products[$i]['model'],
                    'products_name'=>$order->products[$i]['name'],
                    'products_price'=>$order->products[$i]['price'],
                    'final_price'=>$order->products[$i]['final_price'],
                    'products_tax'=>$order->products[$i]['tax'],
                    'products_quantity'=>$order->products[$i]['qty']);

                    tep_db_perform(TABLE_ORDERS_PRODUCTS, $sql_data_array);

                    $order_products_id = tep_db_insert_id();

                    $attributes_exist = '0';
                    if ( isset ($order->products[$i]['attributes']))
                    {
                        $attributes_exist = '1';
                        for ($j = 0, $n2 = sizeof($order->products[$i]['attributes']); $j < $n2; $j++)
                        {
                            if (DOWNLOAD_ENABLED == 'true')
                            {
                                $attributes_query = "select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix, pad.products_attributes_maxdays, pad.products_attributes_maxcount , pad.products_attributes_filename
                                       from ".TABLE_PRODUCTS_OPTIONS." popt, ".TABLE_PRODUCTS_OPTIONS_VALUES." poval, ".TABLE_PRODUCTS_ATTRIBUTES." pa
                                       left join ".TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD." pad
                                       on pa.products_attributes_id=pad.products_attributes_id
                                       where pa.products_id = '".$order->products[$i]['id']."'
                                       and pa.options_id = '".$order->products[$i]['attributes'][$j]['option_id']."'
                                       and pa.options_id = popt.products_options_id
                                       and pa.options_values_id = '".$order->products[$i]['attributes'][$j]['value_id']."'
                                       and pa.options_values_id = poval.products_options_values_id
                                       and popt.language_id = '".$languages_id."'
                                       and poval.language_id = '".$languages_id."'";
                                $attributes = tep_db_query($attributes_query);
                            } else
                            {
                                $attributes = tep_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix from ".TABLE_PRODUCTS_OPTIONS." popt, ".TABLE_PRODUCTS_OPTIONS_VALUES." poval, ".TABLE_PRODUCTS_ATTRIBUTES." pa where pa.products_id = '".$order->products[$i]['id']."' and pa.options_id = '".$order->products[$i]['attributes'][$j]['option_id']."' and pa.options_id = popt.products_options_id and pa.options_values_id = '".$order->products[$i]['attributes'][$j]['value_id']."' and pa.options_values_id = poval.products_options_values_id and popt.language_id = '".$languages_id."' and poval.language_id = '".$languages_id."'");
                            }
                            $attributes_values = tep_db_fetch_array($attributes);

                            $sql_data_array = array ('orders_id'=>$insert_id,
                            'orders_products_id'=>$order_products_id,
                            'products_options'=>$attributes_values['products_options_name'],
                            'products_options_values'=>$attributes_values['products_options_values_name'],
                            'options_values_price'=>$attributes_values['options_values_price'],
                            'price_prefix'=>$attributes_values['price_prefix']);

                            tep_db_perform(TABLE_ORDERS_PRODUCTS_ATTRIBUTES, $sql_data_array);

                            if ((DOWNLOAD_ENABLED == 'true') && isset ($attributes_values['products_attributes_filename']) && tep_not_null($attributes_values['products_attributes_filename']))
                            {
                                $sql_data_array = array ('orders_id'=>$insert_id,
                                'orders_products_id'=>$order_products_id,
                                'orders_products_filename'=>$attributes_values['products_attributes_filename'],
                                'download_maxdays'=>$attributes_values['products_attributes_maxdays'],
                                'download_count'=>$attributes_values['products_attributes_maxcount']);

                                tep_db_perform(TABLE_ORDERS_PRODUCTS_DOWNLOAD, $sql_data_array);
                            }
                        }
                    }
                }

                $cart_cgp_ID = $cartID.'-'.$insert_id;
                tep_session_register('cart_cgp_ID');
            }
        }
        
        return array(
            'title' => MODULE_PAYMENT_CGP_CONFIRMATION_TITLE,
            'fields' => array(array(
                'title' => '',
                'field' => MODULE_PAYMENT_CGP_CONFIRMATION_TEXT
                ))
            );
    }
        
    /**
     * Outputs the html form hidden elements sent as POST data 
     * to the payment gateway
     * 
     * @global type $cart_cgp_ID
     * @global type $HTTP_POST_VARS
     * @global type $customer_id
     * @global type $order
     * @global type $currencies
     */
	function process_button()
	{
        global $cart_cgp_ID;
        global $HTTP_POST_VARS;
        global $customer_id;
        global $order;
        global $currencies;

        $is_test  = (constant("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_MODE") === 'Test' ? 1 : 0);
        $amount   = $this->format_raw($order->info['total'], $order->info['currency']) * 100;
        $order_id = substr($cart_cgp_ID, strpos($cart_cgp_ID, '-')+1);

        $sql_data_array = array(
            'module' => $this->code,
            'date_ordered' => 'now()',
            'orderstr' => str_replace('\'', '\\\'', serialize($order)),
            'customer_id' => $customer_id,
            'is_test' => $is_test,
            'amount' => $amount,
            'order_id' => $order_id
        );
        tep_db_perform('CGP_orders_table', $sql_data_array);
        $last_id = tep_db_insert_id();
        $ref = $order_id . "|" . $last_id;

        $sHashkey   = "";
        $siteID     = constant("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_SITEID");
        $hashKey    = constant("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_KEYCODE");
        $language   = constant("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_LANGUAGE");
        
        // create hash
        if ($hashKey != "") {
            $sHashKey = md5(($is_test == 1 ? "TEST" : "") . $siteID . $amount . $ref . $hashKey);
        }
        
        // payment option
        switch ($this->module_cgp_text) {
            case "VISA":
            case "MASTERCARD":
            case "VPAY":
            case "MAESTRO":
            case "AMERICANEXPRESS":
                $payment_option = tep_draw_hidden_field('option', 'creditcard');
                break;
            
            case "IDEAL":
                $payment_option = tep_draw_hidden_field('option', 'ideal') .
                                  tep_draw_hidden_field('suboption', $HTTP_POST_VARS['ideal_issuer_id']);
                break;
            
            case "DIRECTEBANKING":
            case "SOFORTUEBERWEISUNG":
                $payment_option = tep_draw_hidden_field('option', 'directebanking');
                break;

            case "MISTERCASH":
                $payment_option = tep_draw_hidden_field('option', 'mistercash');
                break;
            
            case "WEBMONEY":
                $payment_option = tep_draw_hidden_field('option', 'webmoney');
                break;
            
            case "PAYPAL":
                $payment_option = tep_draw_hidden_field('option', 'paypal');
                break;
            
            case "GIROPAY":
                $payment_option = tep_draw_hidden_field('option', 'giropay');
                break;
            
            case "BANKTRANSFER":
                $payment_option = tep_draw_hidden_field('option', 'banktransfer');
                break;
            
            case "DIRECTDEBIT":
                $payment_option = tep_draw_hidden_field('option', 'directdebit');
                break;
        }
        
		// generate items list
		$description = "";
		foreach ($order->products as $product) {
			$description .= $product['name'] . "\n";
		}        

        $process_button_string = tep_draw_hidden_field('siteid', $siteID) .
                                 tep_draw_hidden_field('currency', $order->info['currency']) .
                                 tep_draw_hidden_field('description', $description) .
                                 tep_draw_hidden_field('language', $language) .
                                 $payment_option.
                                 tep_draw_hidden_field('test', $is_test) .
                                 tep_draw_hidden_field('amount', $amount) .
                                 tep_draw_hidden_field('ref', $ref) .
                                 tep_draw_hidden_field('email', $order->customer['email_address']) .
                                 tep_draw_hidden_field('first_name', $order->customer['firstname']) .
                                 tep_draw_hidden_field('last_name', $order->customer['lastname']) .
                                 tep_draw_hidden_field('address', $order->customer['street_address']) .
                                 tep_draw_hidden_field('postal_code', $order->customer['postcode']) .
                                 tep_draw_hidden_field('city', $order->customer['city']) .
                                 tep_draw_hidden_field('state', $order->customer['state']) .
                                 tep_draw_hidden_field('phone_number', $order->customer['telephone']) .
                                 tep_draw_hidden_field('country', $order->customer['country']['iso_code_2']) .
                                 tep_draw_hidden_field('return_url', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL')) .
                                 tep_draw_hidden_field('return_url_failed', tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL')) .
                                 tep_draw_hidden_field('shop_version', PROJECT_VERSION) .
                                 tep_draw_hidden_field('plugin_name', 'OsCommerce CGP') .
                                 tep_draw_hidden_field('plugin_version', $this->signature) .
                                 tep_draw_hidden_field('hash', $sHashKey);

        return $process_button_string;
    }
    
    /**
     * Payment verification
     * 
     * @global type $customer_id
     * @global type $order
     * @global type $order_totals
     * @global type $sendto
     * @global type $billto
     * @global type $languages_id
     * @global type $payment
     * @global type $currencies
     * @global type $cart
     * @global type $cart_cgp_ID
     * @global type $payment 
     */
	function before_process()
	{
        global $customer_id, $order, $order_totals, $sendto, $billto, $languages_id, $payment, $currencies, $cart, $cart_cgp_ID;
        global $$payment;
        
		if (empty($order_totals)) {
			require(DIR_WS_CLASSES . 'order_total.php');

			$order_total_modules = new order_total();
			$order_totals = $order_total_modules->process();
		}
        
        $order_id = substr($cart_cgp_ID, strpos($cart_cgp_ID, '-')+1);
		$customer_notification = (SEND_EMAILS == 'true') ? '1' : '0';
		$sql_data_array = array('orders_id' => $this->order_id,
								'orders_status_id' => $order->info['order_status'],
								'date_added' => 'now()',
								'customer_notified' => $customer_notification,
								'comments' => $order->info['comments']);
		tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
        
		// initialized for the email confirmation
		$products_ordered = '';
		$total_weight = 0;
		$total_tax = 0;
		$total_cost = 0;

        for ($i = 0, $n = sizeof($order->products); $i < $n; $i++)
        {
            // Stock Update - Joao Correia
            if (STOCK_LIMITED == 'true')
            {
                if (DOWNLOAD_ENABLED == 'true')
                {
                    $stock_query_raw = "SELECT products_quantity, pad.products_attributes_filename
                                FROM ".TABLE_PRODUCTS." p
                                LEFT JOIN ".TABLE_PRODUCTS_ATTRIBUTES." pa
                                ON p.products_id=pa.products_id
                                LEFT JOIN ".TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD." pad
                                ON pa.products_attributes_id=pad.products_attributes_id
                                WHERE p.products_id = '".tep_get_prid($order->products[$i]['id'])."'";
                    // Will work with only one option for downloadable products
                    // otherwise, we have to build the query dynamically with a loop
                    $products_attributes = $order->products[$i]['attributes'];
                    if (is_array($products_attributes))
                    {
                        $stock_query_raw .= " AND pa.options_id = '".$products_attributes[0]['option_id']."' AND pa.options_values_id = '".$products_attributes[0]['value_id']."'";
                    }
                    $stock_query = tep_db_query($stock_query_raw);
                } else
                {
                    $stock_query = tep_db_query("select products_quantity from ".TABLE_PRODUCTS." where products_id = '".tep_get_prid($order->products[$i]['id'])."'");
                }
                if (tep_db_num_rows($stock_query) > 0)
                {
                    $stock_values = tep_db_fetch_array($stock_query);
                    // do not decrement quantities if products_attributes_filename exists
                    if ((DOWNLOAD_ENABLED != 'true') || (!$stock_values['products_attributes_filename']))
                    {
                        $stock_left = $stock_values['products_quantity']-$order->products[$i]['qty'];
                    } else
                    {
                        $stock_left = $stock_values['products_quantity'];
                    }
                    tep_db_query("update ".TABLE_PRODUCTS." set products_quantity = '".$stock_left."' where products_id = '".tep_get_prid($order->products[$i]['id'])."'");
                    if (($stock_left < 1) && (STOCK_ALLOW_CHECKOUT == 'false'))
                    {
                        tep_db_query("update ".TABLE_PRODUCTS." set products_status = '0' where products_id = '".tep_get_prid($order->products[$i]['id'])."'");
                    }
                }
            } // Decrease stock ended

            // Update products_ordered (for bestsellers list)
            tep_db_query("update ".TABLE_PRODUCTS." set products_ordered = products_ordered + ".sprintf('%d', $order->products[$i]['qty'])." where products_id = '".tep_get_prid($order->products[$i]['id'])."'");

            //------insert customer choosen option to order--------
            $attributes_exist = '0';
            $products_ordered_attributes = '';
            if ( isset ($order->products[$i]['attributes']))
            {
                $attributes_exist = '1';
                for ($j = 0, $n2 = sizeof($order->products[$i]['attributes']); $j < $n2; $j++)
                {
                    if (DOWNLOAD_ENABLED == 'true')
                    {
                        $attributes_query = "select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix, pad.products_attributes_maxdays, pad.products_attributes_maxcount , pad.products_attributes_filename
                                   from ".TABLE_PRODUCTS_OPTIONS." popt, ".TABLE_PRODUCTS_OPTIONS_VALUES." poval, ".TABLE_PRODUCTS_ATTRIBUTES." pa
                                   left join ".TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD." pad
                                   on pa.products_attributes_id=pad.products_attributes_id
                                   where pa.products_id = '".$order->products[$i]['id']."'
                                   and pa.options_id = '".$order->products[$i]['attributes'][$j]['option_id']."'
                                   and pa.options_id = popt.products_options_id
                                   and pa.options_values_id = '".$order->products[$i]['attributes'][$j]['value_id']."'
                                   and pa.options_values_id = poval.products_options_values_id
                                   and popt.language_id = '".$languages_id."'
                                   and poval.language_id = '".$languages_id."'";
                        $attributes = tep_db_query($attributes_query);
                    } else
                    {
                        $attributes = tep_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix from ".TABLE_PRODUCTS_OPTIONS." popt, ".TABLE_PRODUCTS_OPTIONS_VALUES." poval, ".TABLE_PRODUCTS_ATTRIBUTES." pa where pa.products_id = '".$order->products[$i]['id']."' and pa.options_id = '".$order->products[$i]['attributes'][$j]['option_id']."' and pa.options_id = popt.products_options_id and pa.options_values_id = '".$order->products[$i]['attributes'][$j]['value_id']."' and pa.options_values_id = poval.products_options_values_id and popt.language_id = '".$languages_id."' and poval.language_id = '".$languages_id."'");
                    }
                    $attributes_values = tep_db_fetch_array($attributes);

                    $products_ordered_attributes .= "\n\t".$attributes_values['products_options_name'].' '.$attributes_values['products_options_values_name'];
                }
            }
            //------insert customer choosen option eof ----
            
			$total_weight += ($order->products[$i]['qty'] * $order->products[$i]['weight']);
			$total_tax += tep_calculate_tax($total_products_price, $products_tax) * $order->products[$i]['qty'];
			$total_cost += $total_products_price;

			$products_ordered .= $order->products[$i]['qty'] . ' x ' . $order->products[$i]['name'] . ' (' . $order->products[$i]['model'] . ') = ' . $currencies->display_price($order->products[$i]['final_price'], $order->products[$i]['tax'], $order->products[$i]['qty']) . $products_ordered_attributes . "\n";
        }

        // lets start with the email confirmation
        $email_order = STORE_NAME."\n".
                       EMAIL_SEPARATOR."\n".
                       EMAIL_TEXT_ORDER_NUMBER.' '.$order_id."\n".
                       EMAIL_TEXT_INVOICE_URL.' '.tep_href_link(FILENAME_ACCOUNT_HISTORY_INFO, 'order_id='.$order_id, 'SSL', false)."\n".
                       EMAIL_TEXT_DATE_ORDERED.' '.strftime(DATE_FORMAT_LONG)."\n\n";
        
        if ($order->info['comments']) {
            $email_order .= tep_db_output($order->info['comments'])."\n\n";
        }
        
        $email_order .= EMAIL_TEXT_PRODUCTS."\n".
                        EMAIL_SEPARATOR."\n".
                        $products_ordered.
                        EMAIL_SEPARATOR."\n";

		for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
			$email_order .= strip_tags($order_totals[$i]['title']) . ' ' . strip_tags($order_totals[$i]['text']) . "\n";
		}

        if ($order->content_type != 'virtual') {
			$email_order .= "\n" . EMAIL_TEXT_DELIVERY_ADDRESS . "\n" .
							EMAIL_SEPARATOR . "\n" .
                            tep_address_label($customer_id, $sendto, 0, '', "\n")."\n";
        }

        $email_order .= "\n".EMAIL_TEXT_BILLING_ADDRESS."\n".
                        EMAIL_SEPARATOR."\n".
                        tep_address_label($customer_id, $billto, 0, '', "\n")."\n\n";

		if (is_object($$payment)) {
			$email_order .= EMAIL_TEXT_PAYMENT_METHOD . "\n" .
							EMAIL_SEPARATOR . "\n";
			$payment_class = $$payment;
			if (!empty($order->info['payment_method'])) {
				$email_order .= $order->info['payment_method'] . "\n\n";
			} else {
				$email_order .= $payment_class->title . "\n\n";
			}
			if ($payment_class->email_footer) {
				$email_order .= $payment_class->email_footer . "\n\n";
			}
		}
        
        tep_mail($order->customer['firstname'] . ' ' . $order->customer['lastname'], $order->customer['email_address'], EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

        // send emails to other people
        if (SEND_EXTRA_ORDER_EMAILS_TO != '') {
            tep_mail('', SEND_EXTRA_ORDER_EMAILS_TO, EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
        }
        
        // load the after_process function from the payment modules
        $this->after_process();

        $cart->reset(true);

        // unregister session variables used during checkout
        tep_session_unregister('sendto');
        tep_session_unregister('billto');
        tep_session_unregister('shipping');
        tep_session_unregister('payment');
        tep_session_unregister('comments');
        tep_session_unregister('cart_cgp_ID');

        tep_redirect(tep_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL'));
	}

	/**
	 * Post-processing of the payment/order after the order has been finalised
     * 
	 */
	function after_process()
	{
		return false;
	}


	/**
	 * Advanced error handling
     * 
	 */
	function output_error()
	{
		return false;
	}
    
    /**
     * Get error.
     * 
     * @global type $_GET
     * @return array 
     */
    function get_error()
    {
        global $HTTP_GET_VARS;

        if (isset($HTTP_GET_VARS['ErrMsg']) && tep_not_null($HTTP_GET_VARS['ErrMsg'])) {
            $error = stripslashes(urldecode($_GET['ErrMsg']));
        } elseif (isset($HTTP_GET_VARS['Err']) && tep_not_null($HTTP_GET_VARS['Err'])) {
            $error = stripslashes(urldecode($HTTP_GET_VARS['Err']));
        } elseif (isset($HTTP_GET_VARS['error']) && tep_not_null($HTTP_GET_VARS['error'])) {
            $error = stripslashes(urldecode($HTTP_GET_VARS['error']));
        } else {
            $error = MODULE_PAYMENT_CGP_TEXT_ERROR_MESSAGE;
        }

        return array(
            'title' => MODULE_PAYMENT_CGP_TEXT_ERROR,
            'error' => $error
        );
    }

    /**
     * Format prices without currency formatting
     * 
     * @global type $currencies
     * @global type $currency
     * @param float $number
     * @param string $currency_code
     * @param string $currency_value
     * @return float 
     */
	function format_raw($number, $currency_code = '', $currency_value = '')
	{
        global $currencies, $currency;

        if (empty($currency_code) || !$currencies->is_set($currency_code)) {
            $currency_code = $currency;
        }

        if (empty($currency_value) || !is_numeric($currency_value)) {
            $currency_value = $currencies->currencies[$currency_code]['value'];
        }
        
        return number_format(tep_round($number * $currency_value, $currencies->currencies[$currency_code]['decimal_places']), $currencies->currencies[$currency_code]['decimal_places'], '.', '');
	}

    /**
     * Check if configuration_value is stored in DB.
     * 
     * @return boolean 
     */
    function check()
    {
        if (!isset($this->_check)) {
            $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_STATUS'");
            $this->_check = tep_db_num_rows($check_query);
        }
        
        return $this->_check;
    }
    
     /**
     * Fetch array with bank options
     * 
     * @return array
     */
    function get_banks( $choice_question ) {
        $aBankOptions = $this->getBankOptions( $choice_question );
        $aBanks = array();
        foreach ( $aBankOptions as $id => $text ) {
            $aBanks[] = array(
                "id" => $id,
                "text" => $text
            );
        }
        return $aBanks;
    }

    /**
     * Download bank options from Card Gate Plus
     * 
     * @return array
     */
    private function getBankOptions( $choice_question ) {
        $url = 'https://gateway.cardgateplus.com/cache/idealDirectoryRabobank.dat';
        if ( !ini_get( 'allow_url_fopen' ) || !function_exists( 'file_get_contents' ) ) {
            $result = false;
        } else {
            $result = file_get_contents( $url );
        }

        $aBanks = array();

        if ( $result ) {
            $aBanks = unserialize( $result );
            $aBanks[0] = $choice_question;
        }
        if ( count( $aBanks ) < 1 ) {
            $aBanks = array( '0031' => 'ABN Amro',
                '0091' => 'Friesland Bank',
                '0721' => 'ING Bank',
                '0021' => 'Rabobank',
                '0751' => 'SNS Bank',
                '0761' => 'ASN Bank',
                '0771' => 'SNS Regio Bank',
                '0511' => 'Triodos Bank',
                '0161' => 'Van Landschot Bank'
            );
        }
        return $aBanks;
    }


    /**
     * Install method creates `CGP_orders_table` table
     * 
     */
    function install()
    {
        @tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable CGP Module', 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_STATUS', 'True', 'Do you want to accept ".constant("MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_TEXT_TITLE")." payments?', '6', '21', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
        @tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Test/Live Mode', 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_MODE', 'Test', 'Set test or live mode', '6', '21','tep_cfg_select_option(array(\'Test\', \'Live\'), ', now())");
        @tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Site ID', 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_SITEID', '', 'Assigned Site ID by CardGate', '6', '22', now())");
        @tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Hash Key', 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_KEYCODE', '', 'Security hash code from CardGate back-office', '6', '23', now())");
        @tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Gateway language', 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_LANGUAGE', 'en', 'Default gateway language', '6', '24', now())");
        @tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Payment in progress status', 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_ORDER_INITIAL_STATUS_ID', '" . DEFAULT_ORDERS_STATUS_ID . "', 'Set the status of orders when customers are being redirected to the gateway', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
        @tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Payment complete status', 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_ORDER_PAID_STATUS_ID', '" . DEFAULT_ORDERS_STATUS_ID . "', 'Set the status of orders when a payment was successful', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
        @tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Payment failed/canceled status', 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_ORDER_FAILED_STATUS_ID', '" . DEFAULT_ORDERS_STATUS_ID . "', 'Set the status of orders when a payment has failed or been canceled', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
        @tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '9', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
        @tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0' , now())");
        @tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Drop table on deinstall', 'MODULE_PAYMENT_CGP_" . $this->module_cgp_text . "_DROP_TABLE', 'False', 'Drop the `CGP_orders_table` on deinstall of this module. ONLY DO THIS IF ALL THE ORDERS HAVE BEEN PROCESSED AND YOU ARE INSTALLING A NEWER VERSION OF THIS MODULE. AFFECTS ALL CGP MODULES!', '6', '0', 'tep_cfg_select_option(array(\'False\', \'True\'), ', now())");

        $query = 'CREATE TABLE IF NOT EXISTS `CGP_orders_table` (' .
               'ref_id INT(11)  NOT NULL AUTO_INCREMENT PRIMARY KEY,' .
               'date_ordered datetime NOT NULL,' .
               'module VARCHAR(32)  NOT NULL,' .
               'customer_id INT(11) NOT NULL DEFAULT 0,' .
               'orderstr TEXT NOT NULL,' .
               'amount INT(11) NOT NULL DEFAULT 0,' .
               'status INT(11) NOT NULL DEFAULT 0,' .
               'transaction_id INT(11) NOT NULL DEFAULT 0,' .
               'is_test INT(11) NOT NULL DEFAULT 0,' .
               'order_id INT(11) NOT NULL' .
               ')';
        
        tep_db_query($query);
    }

    /**
     * Remove method drops `CGP_orders_table` table
     * 
     */
    function remove()
    {
        $keys = "";
        $keys_array = $this->keys();
        for ($i=0; $i<sizeof($keys_array); $i++) {
            $keys .= "'" . $keys_array[$i] . "',";
        }
        $keys = substr($keys, 0, -1);

        if (MODULE_PAYMENT_CGP_DROP_TABLE === 'True') {
            tep_db_query("DROP TABLE IF EXISTS `CGP_orders_table`");
        }

        tep_db_query("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key IN (" . $keys . ")");
    }

    /**
     * Module installation keys
     * 
     * @return array 
     */
    function keys()
    {
        return array(
            'MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_STATUS',
            'MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_MODE',
            'MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_SITEID',
            'MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_KEYCODE',
            'MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_LANGUAGE',
            'MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_ZONE',
            'MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_SORT_ORDER',
            'MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_ORDER_INITIAL_STATUS_ID',
            'MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_ORDER_PAID_STATUS_ID',
            'MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_ORDER_FAILED_STATUS_ID',
            'MODULE_PAYMENT_CGP_' . $this->module_cgp_text . '_DROP_TABLE'
        );
    }
}
?>